package manov2;

  import java.awt.*;
  import java.awt.event.ActionEvent;
  import java.awt.event.ActionListener;
  import java.awt.event.ItemEvent;
  import java.awt.event.ItemListener;
  import javax.swing.event.ChangeListener;
  import javax.swing.event.ChangeEvent; 
  import java.util.Locale;
  import javax.swing.*;
  
  public class ManoV2 extends JFrame{
      private JButton jb,jx;
      private JToggleButton jg;
      private JSpinner jt,js;
      private JLabel jv,jgra,jval;
      private int flg=0,lx,ly,lw,mx,my,cox,coy,vel=10;
      private double gra=0,inc=0.5;
      private Timer tm;
      private String val;
      private MyIcon mn;
      
      public ManoV2() {
          Locale.setDefault(Locale.Category.FORMAT, Locale.ENGLISH); 
          
          setTitle("Visualizzazione Immagine");
          setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE); 
          getContentPane().setBackground(Color.white); 
          setLayout(null);
          setSize(550, 500);
          setLocationRelativeTo(null);
  
          //Avanza Passo Passo       
          jb = new JButton("Passo");
          jb.addActionListener(new ActionListener() {
              public void actionPerformed(ActionEvent evt) {                              
                  tm.stop();
                  jg.setText("Start");
                  jg.setSelected(false);
                  varia();
                  mn.setGra(gra); 
              }
          });
          jb.setBounds(15, 10, 80, 23);
          add(jb);//--------

          //Cambio di direzione              
          jx = new JButton("Direzione");
          jx.addActionListener(new ActionListener() {
              public void actionPerformed(ActionEvent evt) {                              
                  if(flg==1)flg=0; else flg=1;                
              }
          });
          jx.setBounds(100, 10, 80, 23);
          add(jx);//--------

          //Spinner Incrementa il passo in gradi
          js = new JSpinner();
          js.setLocale(Locale.ENGLISH);
          js.setModel(new SpinnerNumberModel(inc,0.0d,360.0d,0.1d));        
          js.setFont(new java.awt.Font("Tahoma", 1, 14)); 
          js.addChangeListener(new ChangeListener() {
              public void stateChanged(ChangeEvent evt) {
                  inc = Double.parseDouble (""+js.getValue());              
              }
          });
          js.setBounds(240, 9, 60, 25);
          add(js);//--------

           //Spinner incrementa la velocità in millisecondi
          jt = new JSpinner(new SpinnerNumberModel(vel,1,2000,5));
          jt.setFont(new java.awt.Font("Tahoma", 1, 14)); 
          jt.addChangeListener(new ChangeListener() {
              public void stateChanged(ChangeEvent evt) {
                  vel = Integer.parseInt(""+jt.getValue());
                  tm.setDelay(vel);
                  tm.start(); 
              }
          });
          jt.setBounds(360, 9,75, 25);
          add(jt);//--------                         

          //Start/Stop  
          jg = new JToggleButton("Start");
          jg.addItemListener(new ItemListener() {
              public void itemStateChanged(ItemEvent evt) {
                 int status = evt.getStateChange();
                  if(status == ItemEvent.SELECTED){ 
                      jg.setText("Stop");
                      tm.start();
                  }else{
                      jg.setText("Start");
                      tm.stop();
                  }              
              }
          });
          jg.setBounds(440, 10, 80, 23);
         add(jg);//--------

         //etichetta inc-gra 
         jgra = new JLabel("inc-gra");
         jgra.setFont(new Font("Tahoma", 1, 14)); // NOI18N
         jgra.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
         add(jgra);
         jgra.setBounds(188, 10, 50, 20);

         //etichetta inc-val
         jval = new JLabel("inc-val");
         jval.setFont(new Font("Tahoma", 1, 14)); // NOI18N
         jval.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
         add(jval);
         jval.setBounds(308, 10, 50, 20);
         
         //etichetta che visualizza i gradi
         jv = new JLabel("0");
         jv.setFont(new Font("Digital-7Mono", 1, 50));
         jv.setForeground(Color.RED);
         jv.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
         jv.setText("0");
         add(jv);
                    
         //Disegna la manopola         
         mn = new MyIcon();
         mn.setLocation(103, 86);
         add(mn);
         
         setVisible(true);
         //centra la manopola
         cox=getContentPane().getSize().width;
         coy=getContentPane().getSize().height;
         mx=(cox-(mn.getWp()))/2;
         my=(coy-(mn.getHp()))/2;
         mn.setLocation(mx, my);
         mn.setLocation(mx, my);
         
         //centra l'etichetta
         lw=200;
         lx=(cox-lw)/2;
         ly=(coy-60)/2; 
         jv.setBounds(lx, ly, 200, 40);   
         
         //Imposta il Timer        
         tm = new Timer(vel,new ActionListener() {
             public void actionPerformed(ActionEvent evt) {
                 varia();
             }
         });
     }
     
     //controllo della posizione
     private void varia(){        
         if(flg==0){          
             gra=gra+inc;
             if(gra>360){
                gra=gra-360;                    
             }                                  
         }else{
             if(gra==0){
                 gra=360-inc;
             }else{
                 gra=gra-inc;
                 if(gra<0){
                 gra=gra+360;                    
                 } 
             }
         }
        
         mn.setGra(gra);
         val=String.format(new Locale("en"),"%1$.2f",gra);
         jv.setText(val);    
     }
     
     public static void main(String [] args){
         
         new ManoV2();
     }
  }